/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the TikTokControllerActionIdDimensionRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &TikTokControllerActionIdDimensionRequest{}

// TikTokControllerActionIdDimensionRequest struct for TikTokControllerActionIdDimensionRequest
type TikTokControllerActionIdDimensionRequest struct {
	ReportType *string `json:"reportType,omitempty"`
	DataLevel  *string `json:"dataLevel,omitempty"`
}

// NewTikTokControllerActionIdDimensionRequest instantiates a new TikTokControllerActionIdDimensionRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewTikTokControllerActionIdDimensionRequest() *TikTokControllerActionIdDimensionRequest {
	this := TikTokControllerActionIdDimensionRequest{}
	return &this
}

// NewTikTokControllerActionIdDimensionRequestWithDefaults instantiates a new TikTokControllerActionIdDimensionRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewTikTokControllerActionIdDimensionRequestWithDefaults() *TikTokControllerActionIdDimensionRequest {
	this := TikTokControllerActionIdDimensionRequest{}
	return &this
}

// GetReportType returns the ReportType field value if set, zero value otherwise.
func (o *TikTokControllerActionIdDimensionRequest) GetReportType() string {
	if o == nil || IsNil(o.ReportType) {
		var ret string
		return ret
	}
	return *o.ReportType
}

// GetReportTypeOk returns a tuple with the ReportType field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TikTokControllerActionIdDimensionRequest) GetReportTypeOk() (*string, bool) {
	if o == nil || IsNil(o.ReportType) {
		return nil, false
	}
	return o.ReportType, true
}

// HasReportType returns a boolean if a field has been set.
func (o *TikTokControllerActionIdDimensionRequest) HasReportType() bool {
	if o != nil && !IsNil(o.ReportType) {
		return true
	}

	return false
}

// SetReportType gets a reference to the given string and assigns it to the ReportType field.
func (o *TikTokControllerActionIdDimensionRequest) SetReportType(v string) {
	o.ReportType = &v
}

// GetDataLevel returns the DataLevel field value if set, zero value otherwise.
func (o *TikTokControllerActionIdDimensionRequest) GetDataLevel() string {
	if o == nil || IsNil(o.DataLevel) {
		var ret string
		return ret
	}
	return *o.DataLevel
}

// GetDataLevelOk returns a tuple with the DataLevel field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TikTokControllerActionIdDimensionRequest) GetDataLevelOk() (*string, bool) {
	if o == nil || IsNil(o.DataLevel) {
		return nil, false
	}
	return o.DataLevel, true
}

// HasDataLevel returns a boolean if a field has been set.
func (o *TikTokControllerActionIdDimensionRequest) HasDataLevel() bool {
	if o != nil && !IsNil(o.DataLevel) {
		return true
	}

	return false
}

// SetDataLevel gets a reference to the given string and assigns it to the DataLevel field.
func (o *TikTokControllerActionIdDimensionRequest) SetDataLevel(v string) {
	o.DataLevel = &v
}

func (o TikTokControllerActionIdDimensionRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o TikTokControllerActionIdDimensionRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.ReportType) {
		toSerialize["reportType"] = o.ReportType
	}
	if !IsNil(o.DataLevel) {
		toSerialize["dataLevel"] = o.DataLevel
	}
	return toSerialize, nil
}

type NullableTikTokControllerActionIdDimensionRequest struct {
	value *TikTokControllerActionIdDimensionRequest
	isSet bool
}

func (v NullableTikTokControllerActionIdDimensionRequest) Get() *TikTokControllerActionIdDimensionRequest {
	return v.value
}

func (v *NullableTikTokControllerActionIdDimensionRequest) Set(val *TikTokControllerActionIdDimensionRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableTikTokControllerActionIdDimensionRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableTikTokControllerActionIdDimensionRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableTikTokControllerActionIdDimensionRequest(val *TikTokControllerActionIdDimensionRequest) *NullableTikTokControllerActionIdDimensionRequest {
	return &NullableTikTokControllerActionIdDimensionRequest{value: val, isSet: true}
}

func (v NullableTikTokControllerActionIdDimensionRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableTikTokControllerActionIdDimensionRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
